/*

  The Kitchen - Jaime Vives Piqueres 2004-2005

  Entry for the POVCOMP 2004

  i_fridge.inc : Superellipsoid refrigerator (including magnets)

*/

// magnets for the fridge doors
#include "i_seastar.inc"
#declare magnet1=
union{
box{-.5,.5
 scale <2,2,.2>
 texture{
  pigment{checker color White color Gray*.1}
  scale .5
 }
}
sphere{0,.5 
 texture{t_chrome}
 translate -.51*z
}
 translate -.1*z
}
#declare magnet2=
height_field{
  png "hf_tapl"
  water_level 0.01
  texture{
   material_map{
    png "mm_tapl"
    texture{pigment{Clear}}
    texture{pigment{Orange}}
    texture{pigment{Firebrick}}
    texture{pigment{DarkGreen}}
    texture{pigment{Yellow}}
   }
   rotate 90*x
  }
  translate -.5
  rotate -90*x
  scale <10,7.5,.2>
  translate -.1*z
}
#declare magnet_letters=
height_field{
  png "hf_magnet_letters"
  water_level 0.01
  texture{
   pigment{
    image_map{png "im_magnet_letters"}
   }
   finish{Phong_Shiny ambient 0}
   rotate 90*x
  }
  translate -.5
  rotate -90*x
  scale <10,10,.2>*2
  translate -.21*z
}
#declare appeal_paper=
height_field{
  function 128,128{pigment{wrinkles}}
  translate -.5
  rotate -90*x
  texture{
   pigment{image_map{jpeg "im_photo.jpg"} translate -.5} 
   finish{Phong_Shiny}
  }
  scale <36,24,.2>*.5
  rotate 90*y
  rotate -2*z
  rotate 2*x
}
#declare car_photo=
height_field{
  function 128,128{pigment{wrinkles}}
  translate -.5
  rotate -90*x
  texture{
   pigment{image_map{jpeg "recurso.jpg"} translate -.5} 
  }
  scale <19,24,.1>
  rotate 90*y
  rotate -1*z
  rotate -6*x
}
#declare lottery_ticket=
box{-.5,.5
  texture{
   pigment{image_map{png "im_loteria"} translate -.5} 
  }
  scale <63,37,.1>*.2
  rotate 90*y
  rotate 7*x
}


// fake fridge: only the simulation of the two doors
#declare fridge=
union{
 // lower
 superellipsoid{<.05,.025> scale .5 rotate 90*x
  scale <70,150,60>
  texture{t_white_plastic}
  translate 150*.5*y
 }
 difference{
  superellipsoid{<.2,.4> scale <3,1.5,15>}
  cylinder{-2*y,2*y,1 scale <3,1.5,15>*.75}
  texture{t_chrome}
  rotate 90*x
  translate <-35.5,130,27>
 }
 // uper
 superellipsoid{<.05,.025> scale .5 rotate 90*x
  scale <70,40,60>
  texture{t_white_plastic}
  translate (150+20)*y
 }
 difference{
  superellipsoid{<.2,.4> scale <3,1.5,15>}
  cylinder{-2*y,2*y,1 scale <3,1.5,15>*.75}
  texture{t_chrome}
  rotate 90*x
  translate <-35.5,170,27>
 }
 // magnets & other things on the door
 object{magnet1 scale 3 rotate -8*z rotate 90*y translate <-35,140,15>}
 object{magnet2 rotate 6*z rotate 90*y translate <-35,159,12>}
 object{magnet_letters rotate -2*z rotate 90*y rotate -5*x translate <-35,173,15>}
 object{estrella rotate <-90,90,0> translate <-35.5,106,19.5>}
 object{lottery_ticket translate <-35.1,102,15.5>}
 object{appeal_paper translate <-35.3,134,11>}
 object{car_photo translate <-35.3,127,13>}
}
