/*

  The Kitchen - Jaime Vives Piqueres 2004-2005

  Entry for the POVCOMP 2004

  i_glass.inc : simple glass

*/

#declare use_phot=0;
/*
global_settings{
  max_trace_level 32*3
  ambient_light 0.0
  assumed_gamma 1.0
  #if (use_phot)
  photons{
   spacing .025
   autostop 0
  }
  #end
}
*/

// *** GLASS OF WATER ***
// glass material
#if (use_glass)
#declare m_glass=
material{
 texture{
  T_Glass3
  normal{bumps .05 scale 4}
  finish{ambient 0}
 }
 interior{I_Glass}
}
#else
#declare m_glass=
material{
 texture{
  pigment{White}
  finish{diffuse 1}
 }
}
#end
// water material
#if (use_glass)
#declare m_water=
  material{
   texture{
    pigment{rgbt 1}
    normal{waves .1}
    finish{reflection{.1,1 fresnel} conserve_energy ambient 0}
   }
   interior {
     ior 1.333
   }
  }
#else
#declare m_water=
material{
 texture{
  pigment{White}
  finish{diffuse 1}
 }
}
#end
// glass hole
#declare glass_hole=
merge{
 cone{<0,.9,0>,2.5,<0,12.1,0>,2.8}
 intersection{
  sphere{0,1 scale <2.5,.25,2.5>}
  plane{y,0}
  translate 1*y
 }
 hollow
}
// simple glass
#declare glass1=
merge{
 difference{
  cone{<0,0,0>,2.8,<0,12,0>,3}
  object{glass_hole}
 }
 intersection{
  merge{
   torus{2.3,.5}
   cylinder{<0,-.5,0>,<0,.5,0>,2.3}
  }
  plane{y,0.0001}
 }
 intersection{
  torus{2.9,.1}
  plane{y,0 inverse}
  translate 12*y
 }
 hollow
 translate .5*y
}
// cutted glass
#declare glass2=
difference{
 merge{
  difference{
   cone{<0,0,0>,2.5,<0,12,0>,3}
   object{glass_hole}
  }
  intersection{
   merge{
    torus{2.0,.5}
    cylinder{<0,-.5,0>,<0,.5,0>,2.0}
   }
   plane{y,0.0001}
  }
  intersection{
   torus{2.9,.1}
   plane{y,0 inverse}
   translate 12*y
  }
 }
 sphere{0,1 scale <3,2,.25> rotate -3*x translate <0,0,-2.55>}
 sphere{0,1 scale <3,2,.25> rotate -3*x translate <0,0,-2.55> rotate -45*y}
 sphere{0,1 scale <3,2,.25> rotate -3*x translate <0,0,-2.55> rotate 45*y}
 sphere{0,1 scale <3,2,.25> rotate -3*x translate <0,0,-2.55> rotate 90*y}
 sphere{0,1 scale <3,2,.25> rotate -3*x translate <0,0,-2.55> rotate -90*y}
 sphere{0,1 scale <3,2,.25> rotate -3*x translate <0,0,-2.55> rotate -135*y}
 sphere{0,1 scale <3,2,.25> rotate -3*x translate <0,0,-2.55> rotate  135*y}
 sphere{0,1 scale <3,2,.25> rotate -3*x translate <0,0,-2.55> rotate 180*y}
 hollow
 translate .5*y
}
// liquid volume (water in this case)
#declare glass_content=
difference{
 intersection{
  object{glass_hole}
  plane{y,9}
 }
 merge{
  torus{2.3,.4}
  cylinder{<0,-.4,0>,<0,.4,0>,2.3}
  translate 9.2*y
 }
 hollow
}

// join it all to make the glass of water
#declare glass1=
union{
 object{glass1
  material{m_glass}
 }
/*
 object{glass_content 
  material{m_water}
  scale .999999 
 }
*/
}

