/*

  The Kitchen - Jaime Vives Piqueres 2004-2005

  Entry for the POVCOMP 2004

  i_botes.inc: several pots and bottles

*/

#declare ab=array[11]
#declare ab[0]=<0,0,0>;
#declare ab[1]=<0,0,0>;
#declare ab[2]=<2.5,0.01,0>;
#declare ab[3]=<3,.5,0>;
#declare ab[4]=<3.5,1,0>;
#declare ab[5]=<3.5,6,0>;
#declare ab[6]=<3.5,9,0>;
#declare ab[7]=<1.5,13,0>;
#declare ab[8]=<1,15,0>;
#declare ab[9]=<0,15.01,0>;
#declare ab[10]=<0,16,0>;
#if (use_glass)
#declare bote_base=object{meshlathe(ab,.4,9)}
#else
#declare bote_base=object{meshlathe(ab,.3,18)}
#end
#declare bote_vap=
union{
 object{bote_base
  texture{t_plastico_blanco}
 }
 union{
  difference{
   superellipsoid{<.9,.1> rotate 90*x}
   torus{1,.4 scale <1,2,1>}
   scale <1.5,.8,1.5>
  }
  #declare num_cyl=20;
  #declare cnt=0;
  #while (cnt<=num_cyl)
   cylinder{<0,-.7,0>,<0,.7,0>,.2
    translate -1.3*z
    rotate (360*cnt/num_cyl)*y
   }
   #declare cnt=cnt+1;
  #end
  torus{1.5,.1 translate -.8*y}
  cylinder{<0,0,0>,<0,3,0>,.8}
  box{-.5,.5 scale <4,1,1.2> translate 3*y}
  cylinder{<-3,3,0>,<-2,3,0>,.4}
  box{-.5,.5 scale <3,.5,.5> rotate 45*z translate <-1.2,2.3,0>}
  box{-.5,.5 scale <3,1,1> rotate 90*z translate <1.5,2,0>}
  texture{
   pigment{Red*.8+Gray20}
   finish{Shiny reflection .1 ambient 0}
  }
  translate 14.9*y
 }
}

#declare bote_spray=
union{
 // * pitorro
 union{
  cylinder{<0,0,0>,<0,1.3,0>,.5
   texture{pigment{White} finish{Shiny ambient 0}}
   translate 0.4*y
  }
  cylinder{<0,0,0>,<0,.5,0>,.15
   texture{pigment{Pink}}
  }
  translate 21.8*y
 }
 // * cuello
 lathe{
  cubic_spline
  9
  <0,-1>
  <0,0>
  <2.6,0>
  <2,1>
  <1.2,1.2>
  <1.4,1.3>
  <1.4,1.4>
  <0,1.4>
  <0,0>
  texture{pigment{OldGold} finish{Metal reflection 0.05 ambient 0}}
  translate (0.6+19.8)*y
 }
 // * cuerpo
 union{
  cylinder{<0,0,0>,<0,.3,0>,2.75
   texture{Gold_Texture finish{ambient 0}}
  }
  lathe{
   cubic_spline
   8
   <0,-1>
   <0,0>
   <2.7,0>
   <2.8,0.2>
   <2.8,19.1>
   <2.7,19.2>
   <0,19.2>
   <0,19>
   texture{
    material_map{
     tga "mm_laca"
     map_type 2
     texture{pigment{White} finish{Metal ambient 0}}
     texture{Gold_Metal finish{ambient 0}}
     texture{pigment{Red} finish{Metal ambient 0}}
     texture{pigment{SteelBlue} finish{Metal ambient 0}}
     texture{pigment{Yellow} finish{Metal ambient 0}}
    }
    scale 19
   }
   translate 0.3*y
  }
  cylinder{<0,0,0>,<0,.3,0>,2.75
   texture{Gold_Texture finish{ambient 0}}
   translate (0.3+19.8)*y
  }
 }
}
