/*

  The Kitchen - Jaime Vives Piqueres 2004-2005

  Entry for the POVCOMP 2004

  i_jarron.inc : random vase macro

*/

// params: max radius, height, # of points of body, random seed
#macro rand_vase(rv,hv,nlp,r_vs)

#declare rvb=rv*.25+rand(r_vs)*rv*.75;
#declare ilp=0;
#declare ap=array[nlp][2]
#declare vt=.1;

lathe{
 cubic_spline
 nlp+5
 <0,0>
 <rvb,0>
 <rv*rand(r_vs),(hv/nlp)*rand(r_vs)>
 #while (ilp<nlp)
  #declare ap[ilp][0]=rv*.25+rand(r_vs)*rv*.75;
  #declare ap[ilp][1]=(hv/nlp)+hv*ilp/nlp;
  #declare ilp=ilp+1;
 #end
 #declare ilp=0;
 #while (ilp<nlp)
  <ap[ilp][0],ap[ilp][1]>
  #declare ilp=ilp+1;
 #end
 <ap[ilp-1][0]-vt,ap[ilp-1][1]-vt>
 <0,hv>
}


#end // rand_vase() macro


#macro rand_vase2(rv,hv,nlp,r_vs)

#declare rvb=rv*.25+rand(r_vs)*rv*.75;
#declare ilp=0;
#declare ap=array[nlp][2]
#declare vt=.1;

lathe{
 cubic_spline
 nlp+5
 <0,0>
 <rvb,0>
 <rvb*rand(r_vs),(hv/nlp)*rand(r_vs)>
 #while (ilp<nlp)
//  #declare ap[ilp][0]=(rv*.25+rand(r_vs)*rv*.75)*(1-(ilp/nlp));
  #if (ilp<nlp*.5)
  #declare ap[ilp][0]=(rv*.25+rand(r_vs)*rv*.75)*(1-(ilp/nlp));
  #else
  #declare ap[ilp][0]=(rv*.25+rand(r_vs)*rv*.75)*((ilp/nlp));
  #end
  #declare ap[ilp][1]=(hv/nlp)+hv*ilp/nlp;
  #declare ilp=ilp+1;
 #end
 #declare ilp=0;
 #while (ilp<nlp)
  <ap[ilp][0],ap[ilp][1]>
  #declare ilp=ilp+1;
 #end
 <ap[ilp-1][0]-vt,ap[ilp-1][1]-vt>
 <0,hv>
}


#end // rand_vase() macro



